# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: moodle/mod/url/backup/moodle2/backup_url_activity_task.class.php
--- moodle/mod/url/backup/moodle2/backup_url_activity_task.class.php No Base Revision
+++ moodle/mod/url/backup/moodle2/backup_url_activity_task.class.php Locally New
@@ -0,0 +1,78 @@
+<?php
+ 
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+ 
+/**
+ * @package moodlecore
+ * @subpackage backup-moodle2
+ * @copyright 2010 onwards Andrew Davis {@link YOUR_URL_GOES_HERE}
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+ 
+ // This activity has not particular settings but the inherited from the generic
+ // backup_activity_task so here there isn't any class definition, like the ones
+ // existing in /backup/moodle2/backup_settingslib.php (activities section)
+ 
+require_once($CFG->dirroot . '/mod/url/backup/moodle2/backup_url_stepslib.php'); // Because it exists (must)
+//require_once($CFG->dirroot . '/mod/url/backup/moodle2/backup_url_settingslib.php'); // Because it exists (optional)
+ 
+/**
+ * URL backup task that provides all the settings and steps to perform one
+ * complete backup of the activity
+ */
+class backup_url_activity_task extends backup_activity_task {
+ 
+    /**
+     * Define (add) particular settings this activity can have
+     */
+    protected function define_my_settings() {
+        // No particular settings for this activity
+    }
+ 
+    /**
+     * Define (add) particular steps this activity can have
+     */
+    protected function define_my_steps() {
+        $this->add_step(new backup_url_activity_structure_step('url_structure', 'url.xml'));
+    }
+ 
+    /**
+     * Code the transformations to perform in the activity in
+     * order to get transportable (encoded) links
+     */
+    static public function encode_content_links($content) {
+        global $CFG;
+
+        $base = preg_quote($CFG->wwwroot.'/mod/url','#');
+
+        //Access a list of all links in a course
+        $pattern = '#'.$base.'/index\.php\?id=([0-9]+)#';
+        $replacement = '$@URLVIEWLIST*$2@$';
+        $content = preg_replace($pattern, $replacement, $content);
+
+        //Access the link supplying a course module id
+        $pattern = '#'.$base.'/view\.php\?id=([0-9]+)#';
+        $replacement = '$@URLVIEWBYCOURSEMODULE*$2@$';
+        $content = preg_replace($pattern, $replacement, $content);
+
+        //Access the link supplying an instance id
+        $pattern = '#'.$base.'/view\.php\?u=([0-9]+)#';
+        $replacement = '$@URLVIEWBYINSTANCEID*$2@$';
+        $content = preg_replace($pattern, $replacement, $content);
+
+        return $content;
+    }
+}
Index: moodle/mod/url/backup/moodle2/backup_url_stepslib.php
--- moodle/mod/url/backup/moodle2/backup_url_stepslib.php No Base Revision
+++ moodle/mod/url/backup/moodle2/backup_url_stepslib.php Locally New
@@ -0,0 +1,60 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * @package moodlecore
+ * @subpackage backup-moodle2
+ * @copyright 2010 onwards Andrew Davis
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+ 
+/**
+ * Define all the backup steps that will be used by the backup_url_activity_task
+ */
+
+ /**
+ * Define the complete url structure for backup, with file and id annotations
+ */
+class backup_url_activity_structure_step extends backup_activity_structure_step {
+
+    protected function define_structure() {
+ 
+        //the URL module stores no user info
+
+        // Define each element separated
+        $url = new backup_nested_element('url', array('id'), array(
+            'course','name', 'intro', 'introformat', 'externalurl',
+            'display', 'displayoptions', 'parameters', 'timemodified'));
+
+
+        // Build the tree
+        //nothing here for URLs
+
+        // Define sources
+        $url->set_source_table('url', array('id' => backup::VAR_ACTIVITYID));
+
+        // Define id annotations
+        //module has no id annotations
+
+        // Define file annotations
+        $url->annotate_files(array('url_intro'), null); // This file area hasn't itemid
+
+        // Return the root element (url), wrapped into standard activity structure
+        return $this->prepare_activity_structure($url);
+
+    }
+}
Index: moodle/mod/url/lib.php
--- moodle/mod/url/lib.php Base (1.6)
+++ moodle/mod/url/lib.php Locally Modified (Based On 1.6)
@@ -38,6 +38,7 @@
         case FEATURE_COMPLETION_TRACKS_VIEWS: return true;
         case FEATURE_GRADE_HAS_GRADE:         return false;
         case FEATURE_GRADE_OUTCOMES:          return false;
+        case FEATURE_BACKUP_MOODLE2:          return true;
\ No newline at end of file
 
         default: return null;
     }