# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: moodle/user/editadvanced_form.php
--- moodle/user/editadvanced_form.php Base (1.46)
+++ moodle/user/editadvanced_form.php Locally Modified (Based On 1.46)
@@ -40,7 +40,6 @@
         }
         $mform->addElement('select', 'auth', get_string('chooseauthmethod','auth'), $auth_options);
         $mform->addHelpButton('auth', 'chooseauthmethod', 'auth');
-        $mform->setAdvanced('auth');
 
         if (!empty($CFG->passwordpolicy)){
             $mform->addElement('static', 'passwordpolicyinfo', '', print_password_policy());
Index: moodle/user/editlib.php
--- moodle/user/editlib.php Base (1.37)
+++ moodle/user/editlib.php Locally Modified (Based On 1.37)
@@ -128,7 +128,6 @@
     $choices['1'] = get_string('htmlformat');
     $mform->addElement('select', 'mailformat', get_string('emailformat'), $choices);
     $mform->setDefault('mailformat', 1);
-    $mform->setAdvanced('mailformat');
 
     if (!empty($CFG->allowusermailcharset)) {
         $choices = array();
@@ -140,7 +139,6 @@
         }
         $choices = array_merge($choices, $charsets);
         $mform->addElement('select', 'preference_mailcharset', get_string('emailcharset'), $choices);
-        $mform->setAdvanced('preference_mailcharset');
     }
 
     $choices = array();
@@ -149,14 +147,12 @@
     $choices['2'] = get_string('emaildigestsubjects');
     $mform->addElement('select', 'maildigest', get_string('emaildigest'), $choices);
     $mform->setDefault('maildigest', 0);
-    $mform->setAdvanced('maildigest');
 
     $choices = array();
     $choices['1'] = get_string('autosubscribeyes');
     $choices['0'] = get_string('autosubscribeno');
     $mform->addElement('select', 'autosubscribe', get_string('autosubscribe'), $choices);
     $mform->setDefault('autosubscribe', 1);
-    $mform->setAdvanced('autosubscribe');
 
     if (!empty($CFG->forum_trackreadposts)) {
         $choices = array();
@@ -164,7 +160,6 @@
         $choices['1'] = get_string('trackforumsyes');
         $mform->addElement('select', 'trackforums', get_string('trackforums'), $choices);
         $mform->setDefault('trackforums', 0);
-        $mform->setAdvanced('trackforums');
     }
 /* TODO: reimplement editor preferences
     if (!empty($CFG->htmleditor)) {
@@ -173,19 +168,16 @@
         $choices['1'] = get_string('htmleditor');
         $mform->addElement('select', 'htmleditor', get_string('textediting'), $choices);
         $mform->setDefault('htmleditor', 1);
-        $mform->setAdvanced('htmleditor');
     }
 */
     if (empty($CFG->enableajax)) {
         $mform->addElement('static', 'ajaxdisabled', get_string('ajaxuse'), get_string('ajaxno'));
-        $mform->setAdvanced('ajaxdisabled');
     } else {
         $choices = array();
         $choices['0'] = get_string('ajaxno');
         $choices['1'] = get_string('ajaxyes');
         $mform->addElement('select', 'ajax', get_string('ajaxuse'), $choices);
         $mform->setDefault('ajax', 0);
-        $mform->setAdvanced('ajax');
     }
 
     $choices = array();
@@ -193,7 +185,6 @@
     $choices['1'] = get_string('screenreaderyes');
     $mform->addElement('select', 'screenreader', get_string('screenreaderuse'), $choices);
     $mform->setDefault('screenreader', 0);
-    $mform->setAdvanced('screenreader');
 
     $mform->addElement('text', 'city', get_string('city'), 'maxlength="20" size="21"');
     $mform->setType('city', PARAM_MULTILANG);
@@ -230,7 +221,6 @@
             }
         }
         $mform->addElement('select', 'theme', get_string('preferredtheme'), $choices);
-        $mform->setAdvanced('theme');
     }
 
     $mform->addElement('editor', 'description_editor', get_string('userdescription'), null, $editoroptions);
@@ -261,7 +251,6 @@
 
     /// Moodle optional fields
     $mform->addElement('header', 'moodle_optional', get_string('optional', 'form'));
-    $mform->setAdvanced('moodle_optional');
 
     $mform->addElement('text', 'url', get_string('webpage'), 'maxlength="255" size="50"');
     $mform->setType('url', PARAM_URL);