# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: contrib/plugins/blocks/css_theme_tool/block_css_theme_tool.php
--- contrib/plugins/blocks/css_theme_tool/block_css_theme_tool.php Base (1.2)
+++ contrib/plugins/blocks/css_theme_tool/block_css_theme_tool.php Locally Modified (Based On 1.2)
@@ -21,6 +21,8 @@
  */
 class block_css_theme_tool extends block_base {
 
+    protected $visualversion = '0.1.0';
+
     function init() {
         $this->title = get_string('pluginname', 'block_css_theme_tool');
         $this->version = 2010032600;
@@ -41,7 +43,7 @@
         }
 
         $this->content = new stdClass;
-        $this->content->footer = '';
+        $this->content->footer = get_string('version', 'block_css_theme_tool', $this->visualversion);
         $this->content->text = '';
 
         $csssupported = false;
@@ -82,7 +84,24 @@
                 'exporttheme',
                 'exportthemedesc',
                 'showadvancedbodytags',
-                'showadvancedbodytagsdesc'
\ No newline at end of file
+                'showadvancedbodytagsdesc',
+                'opacityprompt',
+                'roundedcorners',
+                'postopleft',
+                'postopright',
+                'posbottomleft',
+                'posbottomright',
+                'set',
+                'fontcolour',
+                'backgroundcolour',
+                'bold',
+                'italic',
+                'underline',
+                'alignleft',
+                'aligncenter',
+                'alignright',
+                'roundedcorners',
+                'opacity'
\ No newline at end of file
             ), 'block_css_theme_tool');
             $settings = array(
                 'fullbodytags' => (get_user_preferences('css_theme_tool_full_body_tags', false))
Index: contrib/plugins/blocks/css_theme_tool/module.js
--- contrib/plugins/blocks/css_theme_tool/module.js Base (1.2)
+++ contrib/plugins/blocks/css_theme_tool/module.js Locally Modified (Based On 1.2)
@@ -134,7 +134,8 @@
                         width: '80%',
                         height : '80%',
                         visible : false,
-                        zIndex : 500
+                        zIndex : 500,
+                        id : 'css_theme_tool'
                     });
                     // Render it on the body (less chance of clipping)
                     this.overlay.render(Y.one(document.body));
@@ -244,7 +245,7 @@
                     selector = selector.replace(/^\s+|\s+$/g,'');
                     var target = Y.one(selector);
                     if (target) {
-                        this.components.cssbuilder.show(target);
+                        this.components.cssbuilder.show(target, selector);
                     } else {
                         alert(M.str.block_css_theme_tool.cannotfindnode);
                     }
@@ -547,6 +548,10 @@
      */
     controlsnode : null,
     /**
+     * An array of components currently initialised
+     */
+    components : [],
+    /**
      * When called this sets the component up to capture the next click to add a rule
      */
     capture_next_click : function() {
@@ -662,27 +667,31 @@
         if (this.controlsnode == null) {
             var controls = this.Y.Node.create('<div class="css_selector_controls"></div>');
             controls.append(this.Y.Node.create('<div class="colorpickerdialogue"></div>'));
-            controls.append(this.Y.Node.create('<div class="control colourpicker"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control backgroundcolourpicker"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control bold"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control italic"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control underline"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control alignleft"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control aligncenter"> </div>'));
-            controls.append(this.Y.Node.create('<div class="control alignright"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control colourpicker" title="'+M.str.block_css_theme_tool.fontcolour+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control backgroundcolourpicker" title="'+M.str.block_css_theme_tool.backgroundcolour+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control bold" title="'+M.str.block_css_theme_tool.bold+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control italic" title="'+M.str.block_css_theme_tool.italic+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control underline" title="'+M.str.block_css_theme_tool.underline+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control alignleft" title="'+M.str.block_css_theme_tool.alignleft+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control aligncenter" title="'+M.str.block_css_theme_tool.aligncenter+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control alignright" title="'+M.str.block_css_theme_tool.alignright+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control roundedcorners" title="'+M.str.block_css_theme_tool.roundedcorners+'"> </div>'));
+            controls.append(this.Y.Node.create('<div class="control opacity" title="'+M.str.block_css_theme_tool.opacity+'"> </div>'));
             controls.append(this.Y.Node.create('<div class="paramcenter"><input type="button" id="highlightaffectedcells" value="'+M.str.block_css_theme_tool.highlight+'" /><input id="commitnewstyle" type="button" value="'+M.str.block_css_theme_tool.save+'" /><input id="cancelnewstyle" type="button" value="'+M.str.block_css_theme_tool.cancel+'" /></div>'));
             controls.one('#commitnewstyle').on('click', this.save, this);
             controls.one('#cancelnewstyle').on('click', this.hide, this);
             controls.one('#highlightaffectedcells').on('mousedown', this.highlight_affected_cells, this);
 
-            new M.block_css_theme_tool.colour_picker(this, controls.one('.colorpickerdialogue'), controls.one('.control.colourpicker'), 'color');
-            new M.block_css_theme_tool.colour_picker(this, controls.one('.colorpickerdialogue'), controls.one('.control.backgroundcolourpicker'), 'background-color');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.bold'), 'font-weight: bold;');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.italic'), 'font-style: italic;');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.underline'), 'text-decoration: underline;');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.alignleft'), 'text-align: left;');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.aligncenter'), 'text-align: center;');
-            new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.alignright'), 'text-align: right;');
+            this.components['colour'] = new M.block_css_theme_tool.colour_picker(this, controls.one('.colorpickerdialogue'), controls.one('.control.colourpicker'), 'color');
+            this.components['backgroundcolor'] = new M.block_css_theme_tool.colour_picker(this, controls.one('.colorpickerdialogue'), controls.one('.control.backgroundcolourpicker'), 'background-color');
+            this.components['roundedcorners'] = new M.block_css_theme_tool.rounded_corners(this, controls.one('.control.roundedcorners'));
+            this.components['opacity'] = new M.block_css_theme_tool.opacity(this, controls.one('.control.opacity'));
+            this.components['bold'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.bold'), 'font-weight: bold;');
+            this.components['italic'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.italic'), 'font-style: italic;');
+            this.components['underline'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.underline'), 'text-decoration: underline;');
+            this.components['alignleft'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.alignleft'), 'text-align: left;');
+            this.components['aligncenter'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.aligncenter'), 'text-align: center;');
+            this.components['alignright'] = new M.block_css_theme_tool.generic_add_style_button(this, controls.one('.control.alignright'), 'text-align: right;');
 
             this.controlsnode = controls;
         }
@@ -701,9 +710,15 @@
         var selectorcontent = this.Y.Node.create('<div class="css_selectors"></div>');
         var selectors = [];
         this.selectorcount = 0;
+
+        var editseletor = null;
+        if (arguments.length > 1) {
+            var editseletor = arguments[1];
+        }
+
         while (target) {
             // Create a selector for each node back to the html tag
-            selectors.push(this.generate_selectors_for_node(target));
+            selectors.push(this.generate_selectors_for_node(target, editseletor));
             target = target.ancestor()
         }
         // Reverse it otherwise its all backwards !
@@ -744,7 +759,7 @@
      * @param {Y.Node} node
      * @return {Y.Node} The selectors node
      */
-    generate_selectors_for_node : function(node) {
+    generate_selectors_for_node : function(node, select) {
         // Get the tag name
         var tag = node.get('nodeName').toLowerCase();
         // Get the tag id
@@ -760,8 +775,17 @@
         if (tagid && tagid != '' && tagid.match && !tagid.match(/^yui_\d/)) {
             // Increase the selector count VERY IMPORTANT
             this.selectorcount++;
-            content.append('<div class="tagid"> <input class="tagselector" type="checkbox" id="tagselector_'+this.selectorcount+'" value="#'+tagid+'" /><label id="tagselector_'+this.selectorcount+'_label">#'+tagid+'<label></div>');
+            var iddiv = this.Y.Node.create('<div class="tagid"> </div>')
+            var idinput = this.Y.Node.create('<input class="tagselector" type="checkbox" id="tagselector_'+this.selectorcount+'" value="#'+tagid+'" />');
+            var idlabel = this.Y.Node.create('<label id="tagselector_'+this.selectorcount+'_label">#'+tagid+'<label>');
+            iddiv.append(idinput).append(idlabel);
+            content.append(iddiv);
+            var regex = new RegExp('#'+tagid+'( |$)');
+            if (select != null && regex.test(select)) {
+                idinput.setAttribute('checked', true);
+                iddiv.addClass('isselected');
         }
+        }
         // Add each class in the classes array to the tag selectors
         if (tagclasses && tagclasses.length > 0) {
             var classes = this.Y.Node.create('<div class="tagclasses"></div>');
@@ -777,7 +801,8 @@
                 var tagclass = this.Y.Node.create('<div class="tagclass"></div>');
                 var tagclassinput = this.Y.Node.create('<input class="tagselector" type="checkbox" id="tagselector_'+this.selectorcount+'" value=".'+c+'" />');
                 var tagclasslabel = this.Y.Node.create('<label id="tagselector_'+this.selectorcount+'_label">.'+c+'<label>');
-                if (i==0 && !M.util.in_array(c, this.nondefaultclasses)) {
+                var cregex = new RegExp('.'+c);
+                if ((i==0 && !M.util.in_array(c, this.nondefaultclasses)) || (select != null && cregex.test(select))) {
                     // Check it by default IF it is the first class and not one of the nondefaultclasses
                     tagclass.addClass('isselected');
                     tagclassinput.set('checked', true);
@@ -1211,7 +1236,158 @@
         return hex;
     }
 }
+
 /**
+ * Rounded corners component
+ *
+ * @class
+ * @constructor
+ * @param {M.block_css_theme_tool.css_builder} cssbuilder
+ * @param {Y.Node} button The button that fires this control
+ */
+M.block_css_theme_tool.rounded_corners = function(cssbuilder, button) {
+    this.cssbuilder = cssbuilder;
+
+    var Y = this.cssbuilder.Y;
+
+    // Create the 4 inputs required to collect the value for the four corners
+    this.nodes.topleft = Y.Node.create('<input type="text" size="5" value="10px" name="rc_topleft" />');
+    this.nodes.topright = Y.Node.create('<input type="text" size="5" value="10px" name="rc_topright" />');
+    this.nodes.bottomleft = Y.Node.create('<input type="text" size="5" value="10px" name="rc_bottomleft" />');
+    this.nodes.bottomright = Y.Node.create('<input type="text" size="5" value="10px" name="rc_bottomright" />');
+    
+    // Create the set and cancel buttons
+    this.nodes.setbutton = Y.Node.create('<input type="submit" value="'+M.str.block_css_theme_tool.set+'" />');
+    this.nodes.cancelbutton = Y.Node.create('<input type="submit" value="'+M.str.block_css_theme_tool.cancel+'" />');
+
+    // Create a node that contains the four inputs
+    var inputs = Y.Node.create('<div class="inputs"></div>');
+    inputs.append(Y.Node.create('<div></div>').append('<label for="rc_topleft">'+M.str.block_css_theme_tool.postopleft+'</label>').append(this.nodes.topleft));
+    inputs.append(Y.Node.create('<div></div>').append('<label for="rc_topright">'+M.str.block_css_theme_tool.postopright+'</label>').append(this.nodes.topright));
+    inputs.append(Y.Node.create('<div></div>').append('<label for="rc_bottomleft">'+M.str.block_css_theme_tool.posbottomleft+'</label>').append(this.nodes.bottomleft));
+    inputs.append(Y.Node.create('<div></div>').append('<label for="rc_bottomright">'+M.str.block_css_theme_tool.posbottomright+'</label>').append(this.nodes.bottomright));
+
+    // Create a node that contains the two buttons
+    var buttons = Y.Node.create('<div class="buttons"></div>');
+    buttons.append(this.nodes.setbutton);
+    buttons.append(this.nodes.cancelbutton);
+
+    // Create the overlay this component will use
+    this.overlay = new Y.Overlay({
+        bodyContent : Y.Node.create('<div></div>').append(inputs).append(buttons),
+        headerContent : '<h2 class="header">'+M.str.block_css_theme_tool.roundedcorners+'</h2>',
+        width: '300px',
+        centered : true,
+        visible : false,
+        zIndex : 5001
+    });
+    this.overlay.render(Y.one(document.body));
+    this.overlay._stdModNode.ancestor().addClass('rounded_corner_component');
+
+    // Attach the set and cancel events
+    this.nodes.cancelbutton.on('click', this.hide, this);
+    this.nodes.setbutton.on('click', this.set, this);
+
+    // Attach the show event
+    button.on('click', this.show, this);
+}
+/**
+ * Properties and methods of the rounded corners component
+ */
+M.block_css_theme_tool.rounded_corners.prototype = {
+    cssbuilder : null,
+    nodes : {
+        setbutton : null,
+        cancelbutton : null,
+        topleft : null,
+        topright : null,
+        bottomleft: null,
+        bottomright : null
+    },
+    overlay : null,
+    overlayshown : false,
+    /**
+     * Show the component overlay
+     */
+    show : function(e) {
+        this.overlay.show();
+        this.overlayshown = true;
+    },
+    /**
+     * Process the form and set the rounded corner attributes
+     */
+    set : function() {
+        var tl = this.nodes.topleft.get('value') || false;
+        var tr = this.nodes.topright.get('value') || false;
+        var bl = this.nodes.bottomleft.get('value') || false;
+        var br = this.nodes.bottomright.get('value') || false;
+
+        if (tl && tr && bl && br && tl == tr  && tr == bl && bl == br) {
+            this.cssbuilder.manual_add_style('border-radius: '+tl);
+            this.cssbuilder.manual_add_style('-moz-border-radius: '+tl);
+            this.cssbuilder.manual_add_style('-webkit-border-radius: '+tl);
+        } else {
+            if (tl) {
+                this.cssbuilder.manual_add_style('border-top-left-radius: '+tl);
+                this.cssbuilder.manual_add_style('-moz-border-radius-topleft: '+tl);
+                this.cssbuilder.manual_add_style('-webkit-border-top-left-radius: '+tl);
+            }
+            if (tr) {
+                this.cssbuilder.manual_add_style('border-top-right-radius: '+tr);
+                this.cssbuilder.manual_add_style('-moz-border-radius-topright: '+tr);
+                this.cssbuilder.manual_add_style('-webkit-border-top-right-radius: '+tr);
+            }
+            if (bl) {
+                this.cssbuilder.manual_add_style('border-bottom-left-radius: '+bl);
+                this.cssbuilder.manual_add_style('-moz-border-radius-bottomleft: '+bl);
+                this.cssbuilder.manual_add_style('-webkit-border-bottom-left-radius: '+bl);
+            }
+            if (br) {
+                this.cssbuilder.manual_add_style('border-bottom-right-radius: '+br);
+                this.cssbuilder.manual_add_style('-moz-border-radius-bottomright: '+br);
+                this.cssbuilder.manual_add_style('-webkit-border-bottom-right-radius: '+br);
+            }
+        }
+        this.hide();
+    },
+    /**
+     * Hide the component overlay
+     */
+    hide : function() {
+        this.overlay.hide();
+        this.overlayshown = false;
+    }
+}
+
+/**
+ * Opacity component
+ *
+ * @class
+ * @constructor
+ * @param {M.block_css_theme_tool.css_builder} cssbuilder
+ * @param {Y.Node} button The button that relates to this component
+ */
+M.block_css_theme_tool.opacity = function(cssbuilder, button) {
+    this.cssbuilder = cssbuilder;
+    button.on('click', this.show, this);
+}
+/**
+ * Properties and methods of the opacity component
+ */
+M.block_css_theme_tool.opacity.prototype = {
+    cssbuilder : null,
+    show : function() {
+        var opacity = prompt(M.str.block_css_theme_tool.opacityprompt);
+        opacity = opacity.replace(/^0?\./, '');
+        opacity = opacity.replace(/\%$/, '');
+        if (opacity.match(/^(\d{1,2}|100)$/)) {
+            this.cssbuilder.manual_add_style('-moz-opacity: .'+opacity);
+            this.cssbuilder.manual_add_style('filter: alpha(opacity='+opacity+')');
+            this.cssbuilder.manual_add_style('opacity: .'+opacity);
+        }
+    }
+}
+/**
\ No newline at end of file
  * Generic add style button component
  * @class
  * @constructor
Index: contrib/plugins/blocks/css_theme_tool/styles.css
--- contrib/plugins/blocks/css_theme_tool/styles.css Base (1.1)
+++ contrib/plugins/blocks/css_theme_tool/styles.css Locally Modified (Based On 1.1)
@@ -1,42 +1,50 @@
-/*.css_builder {background-color:#DDD;border:3px solid blue;}*/
-.css_builder .css_selectors {background-color:#FFF;margin:10px;border:1px solid #BBB;}
-.css_builder .css_selectors .tagselectorbox {border-top:1px solid #DDD;overflow:hidden;font-size:8pt;clear:both;padding:2px;}
-.css_builder .css_selectors .tagselectorbox:first-child {border-top-width:0px;}
-.css_builder .css_selectors .tagselectorbox input[type=checkbox] {font-size:6pt;vertical-align: middle;margin-right:2px;}
-.css_builder .css_selectors .tagselectorbox label {color:#333;}
-.css_builder .css_selectors .tagselectorbox .isselected label {font-weight:bold;}
-.css_builder .css_selectors .tagselectorbox .tagname {width:50px;float:left;}
-.css_builder .css_selectors .tagselectorbox .tagid {width:120px;float:left;}
-.css_builder .css_selectors .tagselectorbox .tagclasses {margin-left:170px;overflow:hidden;}
-.css_builder .css_selectors .tagselectorbox .tagclasses .tagclass {float:left;min-width:33%;}
+.block_css_theme_tool {visibility: hidden;}
+.block_css_theme_tool .content {text-align:center;}
+.block_css_theme_tool .content input {width:90%;margin:3px;border:1px outset #00b3ff; background-color:#D6F3FF;font-size:8pt;-moz-border-radius:5px;}
+.block_css_theme_tool .content .cssnotsupported {font-size:80%;color:#A00;}
+.block_css_theme_tool .content .cssnotsupported hr {border-width:1px 0 0 0;border-color:#A00;width:70%;margin:2px 15%;}
+.block_css_theme_tool .footer  {margin-top:5px;font-size:7pt;}
+.jsenabled .block_css_theme_tool {visibility: visible;}
 
-.css_builder .css_current_selector .tagname,
-.css_builder .css_selectors .tagselectorbox .tagname.isselected label {color:#006BC4;}
-.css_builder .css_current_selector .tagid,
-.css_builder .css_selectors .tagselectorbox .tagid.isselected label {color:#760000;}
-.css_builder .css_current_selector .tagclass,
-.css_builder .css_selectors .tagselectorbox .tagclasses .tagclass.isselected label {color:#097800;}
+#css_theme_tool .css_builder .css_selectors {background-color:#FFF;margin:10px;border:1px solid #BBB;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox {border-top:1px solid #DDD;overflow:hidden;font-size:8pt;clear:both;padding:2px;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox:first-child {border-top-width:0px;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox input[type=checkbox] {font-size:6pt;vertical-align: middle;margin-right:2px;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox label {color:#333;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .isselected label {font-weight:bold;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagname {width:50px;float:left;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagid {width:120px;float:left;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagclasses {margin-left:170px;overflow:hidden;}
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagclasses .tagclass {float:left;min-width:33%;}
 
-.css_builder .css_selector_controls {background-color:#EFEFEF;height:24px;margin:0 10px 10px 10px;}
-.css_builder .css_selector_controls .control {float:left;width:24px;height:24px;background-color:#DDD;}
-.css_builder .css_selector_controls .control.backgroundcolourpicker {background-image:url([[pix:block_css_theme_tool|backgroundColor]]);}
-.css_builder .css_selector_controls .control.colourpicker {background-image:url([[pix:block_css_theme_tool|color]]);}
-.css_builder .css_selector_controls .control.bold {background-image:url([[pix:block_css_theme_tool|bold]]);}
-.css_builder .css_selector_controls .control.italic {background-image:url([[pix:block_css_theme_tool|italic]]);}
-.css_builder .css_selector_controls .control.underline {background-image:url([[pix:block_css_theme_tool|underline]]);}
-.css_builder .css_selector_controls .control.alignleft {background-image:url([[pix:block_css_theme_tool|alignLeft]]);}
-.css_builder .css_selector_controls .control.aligncenter {background-image:url([[pix:block_css_theme_tool|alignCenter]]);}
-.css_builder .css_selector_controls .control.alignright {background-image:url([[pix:block_css_theme_tool|alignRight]]);}
+#css_theme_tool .css_builder .css_current_selector .tagname,
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagname.isselected label {color:#006BC4;}
+#css_theme_tool .css_builder .css_current_selector .tagid,
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagid.isselected label {color:#760000;}
+#css_theme_tool .css_builder .css_current_selector .tagclass,
+#css_theme_tool .css_builder .css_selectors .tagselectorbox .tagclasses .tagclass.isselected label {color:#097800;}
 
-.css_builder .css_selector_controls .colorpickerdialogue {margin:0;height:24px;width:766px;background-color:#FFF;border:1px solid #000;background-image:url(/m20dev3/blocks/css_theme_tool/colourpicker_image.php);visibility:hidden;position:absolute;}
+#css_theme_tool .css_builder .css_selector_controls {background-color:#EFEFEF;height:24px;margin:0 10px 10px 10px;}
+#css_theme_tool .css_builder .css_selector_controls .control {float:left;width:24px;height:24px;background-color:#DDD;}
+#css_theme_tool .css_builder .css_selector_controls .control.backgroundcolourpicker {background-image:url([[pix:block_css_theme_tool|backgroundColor]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.colourpicker {background-image:url([[pix:block_css_theme_tool|color]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.bold {background-image:url([[pix:block_css_theme_tool|bold]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.italic {background-image:url([[pix:block_css_theme_tool|italic]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.underline {background-image:url([[pix:block_css_theme_tool|underline]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.alignleft {background-image:url([[pix:block_css_theme_tool|alignLeft]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.aligncenter {background-image:url([[pix:block_css_theme_tool|alignCenter]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.alignright {background-image:url([[pix:block_css_theme_tool|alignRight]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.roundedcorners {background-image:url([[pix:block_css_theme_tool|roundedCorners]]);}
+#css_theme_tool .css_builder .css_selector_controls .control.opacity {background-image:url([[pix:block_css_theme_tool|opacity]]);}
+#css_theme_tool .css_builder .css_selector_controls .colorpickerdialogue {margin:0;height:24px;width:766px;background-color:#FFF;border:1px solid #000;background-image:url(/m20dev3/blocks/css_theme_tool/colourpicker_image.php);visibility:hidden;position:absolute;}
 
-.css_builder .css_current_selector {font-weight:bold;background-color:#FFF;margin:10px 10px 0 10px;border:1px solid #BBB;min-height:1em;font-size:8pt;color:#333;padding:5px;}
-.css_builder .css_current_selector ul {margin:2px 16px;}
-.css_builder .css_current_selector ul li {list-style: none;margin:2px;}
-.css_builder .css_current_selector ul li .addnewstyle {color:#AAA;padding:2px 0px;}
-.css_builder .css_current_selector ul li.hideme {visibility:hidden;display:none;height:1px;}
-.css_builder .css_current_selector ul li input[type=text] {width:100%;border:1px inset #bbb;padding:1px;}
-.css_builder .css_current_selector ul li .icon {margin-right:5px;vertical-align:middle;cursor:pointer;}
+#css_theme_tool .css_builder .css_current_selector {font-weight:bold;background-color:#FFF;margin:10px 10px 0 10px;border:1px solid #BBB;min-height:1em;font-size:8pt;color:#333;padding:5px;}
+#css_theme_tool .css_builder .css_current_selector ul {margin:2px 16px;}
+#css_theme_tool .css_builder .css_current_selector ul li {list-style: none;margin:2px;}
+#css_theme_tool .css_builder .css_current_selector ul li .addnewstyle {color:#AAA;padding:2px 0px;}
+#css_theme_tool .css_builder .css_current_selector ul li.hideme {visibility:hidden;display:none;height:1px;}
+#css_theme_tool .css_builder .css_current_selector ul li input[type=text] {width:100%;border:1px inset #bbb;padding:1px;}
+#css_theme_tool .css_builder .css_current_selector ul li .icon {margin-right:5px;vertical-align:middle;cursor:pointer;}
 
 #mousemovetrackdiv {background-color:#B2E8FF;z-index:50;}
 #mousemovetrackdiv div {position:fixed;border:0 solid #00A8EF;background-image:url([[pix:block_css_theme_tool|transpixel]])}
@@ -50,16 +58,16 @@
 .viewcssbox .cssrule .selector {font-weight:bold;color:#097800;}
 .viewcssbox .cssrule .icon {margin-right:5px;vertical-align:middle;cursor:pointer;}
 
-.block_css_theme_tool {visibility: hidden;}
-.jsenabled .block_css_theme_tool {visibility: visible;}
-.block_css_theme_tool .content {text-align:center;}
-.block_css_theme_tool .content input {width:90%;margin:3px;border:1px outset #00b3ff; background-color:#D6F3FF;font-size:8pt;-moz-border-radius:5px;}
-.block_css_theme_tool .content .cssnotsupported {font-size:80%;color:#A00;}
-.block_css_theme_tool .content .cssnotsupported hr {border-width:1px 0 0 0;border-color:#A00;width:70%;margin:2px 15%;}
-
-.yui3-overlay .yui3-widget-bd.css_builder_overlay {background-color:#EEE;padding:10px;border:1px solid #333;}
+#css_theme_tool .css_builder_overlay {background-color:#EEE;padding:10px;border:1px solid #333;}
 .yui3-overlay .yui3-widget-bd.colourpicker_preview {background-color:#FFF;border:2px solid #000;}
 
+.rounded_corner_component {background-color:#EEE;border:1px solid #333;overflow:hidden;position:fixed;}
+.rounded_corner_component .yui3-widget-hd .header {margin:0;padding:5px;}
+.rounded_corner_component .yui3-widget-bd .inputs {margin:5px 10px;}
+.rounded_corner_component .yui3-widget-bd .inputs div {clear:both;margin-bottom:2px;}
+.rounded_corner_component .yui3-widget-bd .inputs label {width:45%;text-align:right;font-weight:bold;display:block;float:left;margin-right:1em;}
+.rounded_corner_component .yui3-widget-bd .buttons {margin:5px 10px;}
+
\ No newline at end of file
 .cssbuilder_bodywash {position:fixed;top:0px;left:0px;width:100%;height:100%;background-color:#FFF;opacity:0.7;}
 .cssbuilder_cellhighlight {border:1px solid #00b3ff;background-color:#D6F3FF;position:absolute;z-index:10000;}
 